/* pyv */

{
  /* <div class="paypal-cart" data-id="test-cart-id"><div class="buttons"><div class="paypal-item" data-id="youth" data-cost="10"><div class="paypal-item-name">Youth</div></div><div class="paypal-item" data-id="leader" data-cost="10"><div class="paypal-item-name">Leader</div></div></div><div class="paypal-confirmation"><span>Payment successful.</span></div><noscript><p class="javascript-required">You must enable JavaScript to checkout via PayPal.</p></noscript></div> */
}

const ITEM_REMOVE = `<div class="paypal-item-remove m-button primary focusable" title="-1" role="button" tabindex="0"><i class="icon-minus"></i></div>`,
  ITEM_ADD = `<div class="paypal-item-add m-button primary focusable" title="+1" role="button" tabindex="0"><i class="icon-plus"></i></div>`,
  CHECKOUT = `<div class="paypal-order">
    <div class="paypal-order-total"></div>
    <div class="paypal-order-checkout m-button primary focusable" role="button" tabindex="0"><span>Checkout with</span> <span title="PayPal" class="paypal-checkout-logo"></span></div>
  </div>`.replace(/\s+/g, ' ');

const createElement = (html) => {
    const tmpl = document.createElement('template');
    tmpl.innerHTML = html.trim();
    return tmpl.content.firstChild;
  },
  getDataAttrAsInt = (elem, attr) => {
    let value = parseInt(elem.dataset[attr]);
    if (isNaN(value)) value = 0;
    return value;
  },
  onClick = (elem, handler) => {
    elem.addEventListener('click', handler);
    elem.addEventListener('keydown', (event) => {
      if (['Space', 'Enter'].includes(event.code)) handler();
    });
  };

const hydrateCart = (cart) => {
  const { id: cartId } = cart.dataset,
    order = createElement(CHECKOUT),
    items = [...cart.querySelectorAll('.paypal-item')],
    total = order.querySelector('.paypal-order-total'),
    checkout = order.querySelector('.paypal-order-checkout'),
    confirmation = cart.querySelector('.paypal-confirmation');
  if (confirmation) confirmation.before(order);
  else cart.append(order);

  const getCount = (item) => getDataAttrAsInt(item, 'count'),
    getCost = (item) => getDataAttrAsInt(item, 'cost'),
    getTotal = () =>
      items.reduce((charge, item) => {
        return charge + getCount(item) * getCost(item);
      }, 0);

  const updateTotal = () => (total.innerText = `$${getTotal()}`),
    updateCount = (item, increment) => {
      item.dataset.count = Math.max(getCount(item) + increment, 0);
      updateTotal();
    };
  updateTotal();

  const showConfirmation = () => {
    if (!confirmation) return;
    confirmation.style.setProperty('display', 'flex');
  };

  for (const item of items) {
    const add = createElement(ITEM_ADD),
      remove = createElement(ITEM_REMOVE);
    onClick(add, () => updateCount(item, +1));
    onClick(remove, () => updateCount(item, -1));
    item.append(remove, add);
  }

  onClick(checkout, () => {
    console.log({
      cart: cartId,
      items: items.map((item) => {
        return {
          id: item.dataset.id,
          count: getCount(item),
        };
      }),
    });
    showConfirmation();
  });
};

document.addEventListener('DOMContentLoaded', () => {
  const carts = document.querySelectorAll('.paypal-cart');
  for (const cart of carts) hydrateCart(cart);
});
/* /pyv */
